=== debian/watch ===
version=3
	https://github.com/mailru/tarantool/tags \
		.*/tarball/(\d+(?:\.\d+)+)
